/*
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;

import Applet.AppletMathGraph32;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import objets.CCalcul;
import objets.CCalculBase;
import objets.CListeObjets;
import types.ErreurCalculException;
import types.Int;

/**
 *
 * @author Yves
 */
@SuppressWarnings("serial")
public class CalculReelDlg extends MtgDlg {
  
	private CCalcul calculAModifier; // Pointeur sur le calcul  modifier.
	private boolean modification; // true si on modifie un calcul dj cr
  private javax.swing.JButton btnCancel;
  private javax.swing.JButton btnOK;
  private JLabel label1;
  private JLabel label2;
  private javax.swing.JTextField editeurFormule;
  private javax.swing.JTextField editeurNom;
  private PaneBoutonsListeValeursEtFonctionsTextField paneListeValeurEtFonctions;
  
  public CalculReelDlg(AppletMathGraph32 appletInit, CCalcul calculAModifierInit) {
    super (AppletMathGraph32.getString("ch22"), true, appletInit);
    calculAModifier = calculAModifierInit;
    initComponents();
    getRootPane().setDefaultButton(btnOK);    
  }
  private void initComponents() {
    btnOK = new javax.swing.JButton(AppletMathGraph32.getString("btnOK"));
    btnOK.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnOKActionPerformed(evt);
      }
    });    
    btnCancel = new javax.swing.JButton(AppletMathGraph32.getString("btnCancel"));
    btnCancel.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnCancelActionPerformed(evt);
      }
    });
    btnOK.setPreferredSize(btnCancel.getPreferredSize());
    
    label1 = new JLabel(AppletMathGraph32.getString("creerCalculDlg1"), JLabel.RIGHT);
    label1.setRequestFocusEnabled(false);
    label2 = new JLabel(AppletMathGraph32.getString("creerCalculDlg2"), JLabel.RIGHT);
    label2.setRequestFocusEnabled(false);
    editeurFormule = new javax.swing.JTextField(null, 40);
    editeurFormule.setAutoscrolls(true);
    editeurNom = new javax.swing.JTextField(null,8);
  	CListeObjets liste = applet.listePourConstruction(); // Ajout version 4.6
    int indmax = liste.indexOf(calculAModifier);
    boolean modification = (indmax != -1);
    if (!modification) indmax = liste.size() - 1;
    else {
      editeurFormule.setText(calculAModifier.calcul.chaineCalculSansPar(null));
      editeurNom.setText(calculAModifier.nom());
      editeurNom.setEditable(false);
    }
    paneListeValeurEtFonctions = new PaneBoutonsListeValeursEtFonctionsTextField
    		(applet, editeurFormule, true, indmax, false, true, true);
    
    JPanel paneLeft = new JPanel();
    JPanel paneRight = new JPanel();
    getContentPane().setLayout(new FlowLayout());
    paneLeft.setLayout(new GridBagLayout());
    paneRight.setLayout(new GridLayout(2, 1, 0, 5));
    
    GridBagConstraints constraints = new GridBagConstraints();
    constraints.insets.bottom = 5;
    constraints.insets.top = 5;
    constraints.insets.left = 5;
    constraints.insets.right = 5;
    
    setConstraints(constraints, 0, 0, 1, 1, 40, 40, GridBagConstraints.NONE, GridBagConstraints.WEST);
    paneLeft.add(label1, constraints);
    
    setConstraints(constraints, 1, 0, 1, 1, 60, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
    constraints.insets.bottom = 0;
    paneLeft.add(editeurNom, constraints);
    
    setConstraints(constraints, 0, 1, 1, 1, 0, 30, GridBagConstraints.NONE, GridBagConstraints.EAST);
    paneLeft.add(label2, constraints);
   
    setConstraints(constraints, 1, 1, 1, 1, 0, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
    paneLeft.add(editeurFormule, constraints);
    
    constraints.insets.bottom = 5;
    setConstraints(constraints, 1, 2, 1, 1, 0, 30, GridBagConstraints.NONE, GridBagConstraints.WEST);
    paneLeft.add(paneListeValeurEtFonctions, constraints);
    
    paneRight.add(btnOK);
    paneRight.add(btnCancel);
    
    getContentPane().add(paneLeft);
    getContentPane().add(paneRight);
    pack();
  }
  private void btnOKActionPerformed(java.awt.event.ActionEvent evt) {                                      
    CListeObjets listePr = applet.listePourConstruction(); // Ajout version 4.6
    String chNom = editeurNom.getText();
    // On regarde d'abord si le nom propos est correct et non vide
    if ((chNom.length() == 0) || !EditeurNomCalcul.validationNomVariableOuCalcul(chNom)) {
      applet.dialogueAvertissement(AppletMathGraph32.getString("ch1"));
      editeurNom.requestFocus();
      return;
    }
    if (chNom.equals("i")) {
      applet.dialogueAvertissement(AppletMathGraph32.getString("ch2"));
      editeurNom.requestFocus();
      return;
    }
    if (listePr.egalNomValeurOuFonctionOuMesure(chNom, applet.listeConstruction.size()-1)) {
      applet.dialogueAvertissement(AppletMathGraph32.getString("ch3"));
      editeurNom.requestFocus();
      return;
    }
    //Le nom est correct. On vrifie maintenant le calcul
    String chCalcul = editeurFormule.getText();
    Int indErr = new Int();
    // On n'autorise d'utiliser que les objets crs par l'utilisateur
    if (CCalculBase.verifieSyntaxe(listePr, chCalcul, indErr, 
        applet.listeConstruction.size()-1, null)) {
      CCalculBase calc = CCalculBase.creeCalculBase(chCalcul ,listePr, 0,
              chCalcul.length()-1, null);
      try {
        calc.listeProprietaire.initialiseNombreIterations();
        @SuppressWarnings("unused")
				double v = calc.resultat(false);
      }
      catch (ErreurCalculException e) {
        applet.dialogueAvertissement(AppletMathGraph32.getString("ch4"));
        editeurFormule.requestFocus();
        return;
      }
      calculAModifier.calcul = calc;
      calculAModifier.chaineCalcul = chCalcul;
      if (!modification) calculAModifier.nomCalcul = chNom;
      else applet.gestionnaire.enregistreFigureEnCours(getString("chaineOutil48"));
      setRetourOK(true);
      dispose();
    }
    else {
      applet.dialogueAvertissement(AppletMathGraph32.getString("ch5"));
      editeurFormule.setCaretPosition(indErr.getValue());
      editeurFormule.requestFocus();
      return;     
    }
  }                                     

  private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {                                          
    dispose();
  }         
}
