/*
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;
import Applet.AppletMathGraph32;
import objets.*;

/**
 *
 * @author Yves
 */
@SuppressWarnings("serial")
public class EditeurRayon extends EditeurValeurDynamique {
  
  /** Creates a new instance of EditeurRayon */
  public EditeurRayon(AppletMathGraph32 appletInit, 
      CValeurAssocieeAVariable valInit, CElementBase objetInit) {
    super(appletInit,  valInit,  objetInit); 
  }

   /**
   * Fonction charge de vrifier si la rponse, quand elle est correcte, est valide
   * pour le type de valeur attendu. Par exemple, le rayon d'un cercle doit tre non nul.
   * Renvoie true par dfaut et doit tre redfinie pour tous les descendants.
   *
  */
  public boolean valeurAcceptee(double v) {
    if (v < 0) {
      applet.dialogueAvertissement(AppletMathGraph32.getString("ch9"));
      requestFocus();
    }
    return (v >0);
  }
}
