/*
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;

import Applet.AppletMathGraph32;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import objets.CElementGraphique;
import objets.CListeObjets;
import objets.CPointAncetre;

import types.NatureObjet;

/**
 *
 * @author Yves
 */
@SuppressWarnings("serial")
public class EntreeNomDlg extends MtgDlg {
  CElementGraphique elementAssocie; // L'lment que l'on cherche  renommer
  private javax.swing.JButton btnCancel;
  private javax.swing.JButton btnOK;
  private javax.swing.JTextField editeurNom;
  private javax.swing.JLabel label1;
  // End of variables declaration

  public EntreeNomDlg(AppletMathGraph32 appletInit, CElementGraphique elementAssocieInit) {
    super (AppletMathGraph32.getString("ch21"), true, appletInit);
    elementAssocie = elementAssocieInit;
    initComponents();
    getRootPane().setDefaultButton(btnOK);
    editeurNom.setText(elementAssocie.rendNom());
    editeurNom.setSelectionStart(0);
    editeurNom.setSelectionEnd(editeurNom.getText().length());
    editeurNom.requestFocus();
  }
  private void initComponents() {
    label1 = new JLabel(AppletMathGraph32.getString("entreeNomDlg1"), JLabel.RIGHT);
    label1.setRequestFocusEnabled(false);
    editeurNom = new javax.swing.JTextField();
    editeurNom.setColumns(8);
    btnOK = new javax.swing.JButton(AppletMathGraph32.getString("btnOK"));
    btnOK.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnOKActionPerformed(evt);
      }
    });    
    btnCancel = new javax.swing.JButton(AppletMathGraph32.getString("btnCancel"));
    btnCancel.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnCancelActionPerformed(evt);
      }
    });
    btnOK.setPreferredSize(btnCancel.getPreferredSize());
    JPanel panePrincipal = new JPanel();
    JPanel paneRight = new JPanel();
    panePrincipal.setLayout(new FlowLayout());
    paneRight.setLayout(new GridLayout(2,1,0,5));
    paneRight.add(btnOK);
    paneRight.add(btnCancel);
    panePrincipal.add(label1);
    panePrincipal.add(editeurNom);
    panePrincipal.add(paneRight);
    setContentPane(panePrincipal);
    pack();
  }
  private void btnOKActionPerformed(java.awt.event.ActionEvent evt) {
    // CListeObjets liste = applet.listePr; Modifi version 4.6
  	CListeObjets liste = applet.listePourConstruction(); 	
    String ch = editeurNom.getText();
    if (((elementAssocie.getNature() & (NatureObjet.NToutPoint | NatureObjet.NDroite)) != 0) && 
            elementAssocie.rendNom().length() != 0) {
      CElementGraphique el = (CPointAncetre) elementAssocie;
      if ((ch.length() == 0) && liste.nomIndispensable(el)) {
        dialogueAvertissement(AppletMathGraph32.getString("ch33"));
        editeurNom.setText(elementAssocie.rendNom());
        editeurNom.requestFocus();
        return;
      }
    }
    if (liste.validationNomElement(ch)) {
      if (liste.existeMemeNomNonIntermediaire(elementAssocie,ch)) {
        dialogueAvertissement(AppletMathGraph32.getString("ch20"));
        editeurNom.requestFocus();
        return;
      }
      else {      
        elementAssocie.donneNom(ch);
        applet.repaintFigureSansCalcul();
        dispose();
      }
    }
    else {
      dialogueAvertissement(AppletMathGraph32.getString("ch19"));
      return;
    }
  }                                     

  private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {                                          
    dispose();
  }      
}
