package dialogs;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import Applet.AppletMathGraph32;
import types.FonteNom;

@SuppressWarnings("serial")
public class ListeFonctionsPredefiniesDlg extends MtgDlg implements MouseListener {
	private boolean fonctionsRelles; // True si on propose les fonctions complexes
	private JTextField editeur; // Le textField dans lequel sera envoy le choix
  private ListeFonctionsPredefinies listeFonctionsPredefinies;
  private JButton btnOK, btnCancel;  
  private JTextArea info; // Contiendra l'info sur la syntaxe de la fonction slectionne
  public ListeFonctionsPredefiniesDlg(AppletMathGraph32 appletInit, JTextField editeurInit, boolean fonctionsReellesInit) {
    super(getString("choixFonctionDlg1"),true, appletInit);
    editeur = editeurInit;
    fonctionsRelles = fonctionsReellesInit;
    JLabel label = new JLabel(getString("choixFonctionDlg2"));
    btnCancel = new JButton(getString("btnCancel"));
    btnCancel.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnCancelActionPerformed();
      }
    });    
    btnOK = new JButton(getString("btnOK"));
    btnOK.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnOKActionPerformed();
      }
    });    
    btnOK.setPreferredSize(btnCancel.getPreferredSize());
    listeFonctionsPredefinies = new ListeFonctionsPredefinies(fonctionsRelles);
    info = new JTextArea();
    info.setFont(FonteNom.getFonteNom(2, FonteNom.Normal));    
    JScrollPane scrollPane = new JScrollPane(info, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
    info.setEditable(false);
    info.setColumns(45);
    info.setEditable(false);
    info.setLineWrap(false);
    info.setRows(4);
    
    // JPanel pane = new JPanel();
    GridBagLayout gridBag = new GridBagLayout();
    getContentPane().setLayout(gridBag);
    GridBagConstraints constraints = new GridBagConstraints();
    setConstraints(constraints, 0, 0, 1, 1, 80, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
    constraints.insets.top = 4;
    constraints.insets.bottom = 4;
    constraints.insets.left = 5;
    constraints.insets.right = 5;

    getContentPane().add(label, constraints);
    constraints.insets.top = 0;
    constraints.insets.bottom = 5;    
    setConstraints(constraints, 0, 1, 1, 1, 0, 70, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
    JScrollPane scrollList = new JScrollPane(listeFonctionsPredefinies, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
    
    getContentPane().add(scrollList, constraints);
    
    
    setConstraints(constraints, 0, 2, 2, 1, 100, 30, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER);
    getContentPane().add(scrollPane, constraints);
    
    constraints.insets.bottom = 0;
    
    JPanel paneDroit = new JPanel(); // Pour mettre les deux boutons en haut et  droite
    paneDroit.setLayout(new GridLayout(2,1,0,5));
    paneDroit.add(btnOK);
    paneDroit.add(btnCancel);
    
    setConstraints(constraints, 1, 1, 1, 1, 20, 0, GridBagConstraints.NONE, GridBagConstraints.NORTHEAST);
    getContentPane().add(paneDroit, constraints);

    listeFonctionsPredefinies.addMouseListener(this);
    listeFonctionsPredefinies.addListSelectionListener(new ListSelectionListener() {
      public void valueChanged(ListSelectionEvent evt) {
      	listeFonctionsPredefiniesSelectionChanged();
      }
    });
    getRootPane().setDefaultButton(btnOK);
    listeFonctionsPredefiniesSelectionChanged();
    pack();  
    
  }
  
  private void btnOKActionPerformed() {
    String chfin;
		int i = editeur.getCaretPosition();
    String ch = editeur.getText();
    String nom = listeFonctionsPredefinies.nomFonction();
    String chdebut = nom + "(";
    int longNom = nom.length();
  	// Si on colle le nom d'une fonction on colle aussi la parenthse
  	// et les virgules ventuelles
    int decalage = 0;
    int nombreVariables = listeFonctionsPredefinies.nombreVariables();
  	if (nombreVariables == 1) {
  		chfin = ")";
  		decalage++;
  	}
  	else {
    	if (nombreVariables == 2) {
    		chfin = ",)";
    		decalage++;
    	}
    	else {
      	if (nombreVariables == 3) {
      		chfin = ",,)";
      		decalage++;
      	}
      	else{
        	if (nombreVariables == 4) {
        		chfin = ",,,)";
        		decalage++;
        	}
        	else {
	        	if (nombreVariables == 5) {
	        		chfin = ",,,,)";
	        		decalage++;
	        	}
	        	else chfin = "";
        	}
      	}
    	}
  	}
		String selection = editeur.getSelectedText();
		if (selection != null) {
			i = ch.indexOf(selection) + selection.length();			
			if (nombreVariables >= 1) decalage++;
			editeur.setText(ch.substring(0,editeur.getSelectionStart()) + chdebut
					+ selection + chfin + ch.substring(editeur.getSelectionEnd()));
		}
		else {
	    String ch2 = ch.substring(0, i) + chdebut + chfin + ch.substring(i);
	    editeur.setText(ch2);
		}
		dispose(); // Modification version 4.5.2. Doit tre avant les deux lignes suivantes
		// pour que dans le cas o on dite un mtgFormulaEditor celui retrouve bien le focus
	  editeur.setCaretPosition(longNom + i + decalage);
	  editeur.requestFocus();
		// dispose(); 
  }
  
  private void btnCancelActionPerformed() {
  	dispose();
	  editeur.requestFocus(); // Ajout version 4.5.2
  }
  
  private void listeFonctionsPredefiniesSelectionChanged() {
		info.setText(listeFonctionsPredefinies.syntaxe());
		info.setCaretPosition(0);
  }

  
  public void mouseClicked(MouseEvent evt) {
    if (evt.getClickCount() == 2) {
    	btnOKActionPerformed();
    }
  }

  public void mouseEntered(MouseEvent evt) {
  }

  public void mouseExited(MouseEvent evt) {
  }

  public void mousePressed(MouseEvent evt) {
  }

  public void mouseReleased(MouseEvent evt) {
  }   

}
