/*
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;
import java.util.*;
import javax.swing.*;
import objets.*;
import types.*;

/**
 *
 * @author Yves
 */
@SuppressWarnings("serial")
public class ListeValeurs extends JList<String> {
  private CListeObjets liste; // La liste contenant les valeurs  afficher
  private int indiceMaxi; // l'indice maxi permis pour un objet  insrer dans la liste
  
  /**
   * Creates a new instance of ListeValeurs 
   */
  public ListeValeurs(CListeObjets listeInit, int indiceMaxiInit) {
    super();
    setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    liste = listeInit;
    indiceMaxi = indiceMaxiInit;
    int i = 0;
    
    Vector<String> values = new Vector<String> ();
    // On ajoute les noms des objets de type valeurs  la liste
    ListIterator<CElementBase> li = liste.listIterator();
    while (i <= indiceMaxi)
    {
      CElementBase elb = (CElementBase) (li.next());
      if ((elb.getNatureCalcul() & NatureCalcul.NTouteValeurReelle) != 0) {
        values.add(elb.nom());
      }
      i++;
    }
    setListData(values);
    setVisibleRowCount(6);

    setSelectedIndex(0);
  }  
}
