/*
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;
import java.awt.*;
import javax.swing.*;

import types.Bool;
import Applet.*;

/**
 *
 * @author Yves
 * Ancetre de tous les dialogues utiliss dans l'applet
 */
@SuppressWarnings("serial")
public class MtgDlg extends JDialog {
  protected AppletMathGraph32 applet;
  private Bool retourOK = new Bool(false); // Contient true si la boite de dialogue a t cre en cliquant
                  // sur OK et false sinon
  public boolean getRetourOK() {
    return retourOK.getValue();
  }
  public void setRetourOK(boolean value) {
  	retourOK.setValue(value);
  }
  
  /** Creates a new instance of MtgDlg */
  public MtgDlg(String title, boolean modal, AppletMathGraph32 appletInit) {
    super(appletInit.getParentFrame(), title, modal);
    applet = appletInit;
    retourOK = new Bool(false);
  }
  
  public static String getString(String key) {
  	return AppletMathGraph32.getString(key);
  }
  
  /* Fonction affichant un dialogue d'avertissement au centre de l'cran
   */
  public final static void dialogueAvertissement(String texte) {
    JOptionPane.showMessageDialog(null, texte, "Avertissement", JOptionPane.WARNING_MESSAGE);
  }

  /**
   * Fonction permettant de spcifier les champs d'un GridBagConstraints qui permet de
   * spcifier comment sont agencs les composants d'une boite de dialogue
   **/
  public static final void setConstraints(GridBagConstraints gbc, int gx, int gy, int gw, int gh, 
    int wx, int wy, int fill, int anchor) {
    gbc.gridx = gx;
    gbc.gridy = gy;
    gbc.gridwidth = gw;
    gbc.gridheight = gh;
    gbc.anchor = anchor;
    gbc.fill = fill;
  }
  
  /* Renvoie la valeur contenue dans retourOK ce qui permet de savoir si la boite
   * de dialogue a t ferme en validant
  */
  public final boolean retourOK() {
    return retourOK.getValue();
  }
  
}
