/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;


import glob.*;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import Applet.AppletMathGraph32;
import objets.CVariableBornee;

/**
 * Dialogue permettant de crer ou modifier une variable
 * @author Yves
 * Dans la version Applet, pas de modification possible du nom
 */
@SuppressWarnings("serial")
public class VariableDlg extends MtgDlg {
	private CVariableBornee variableAModifier;
	private JButton btnOK;
	private JButton btnCancel;
  private JLabel label1;
  private JLabel label2;
  private JLabel label3;
  private JLabel label4;
  private JLabel label5;
  private JTextField editeurNom;
  private EditeurValeurConstante editeurValeurMini;
  private EditeurValeurConstante editeurValeurMaxi;
  private EditeurValeurConstante editeurValeurPas;
  public EditeurValeurConstante editeurValeurActuelle;
  
  // Dans la version applet,pas de modification possible du nom de la variable
  public VariableDlg(AppletMathGraph32 appletInit, CVariableBornee variableAModifierInit) {
  	super(AppletMathGraph32.getString("variableDlg1"), true, appletInit);
  	variableAModifier = variableAModifierInit;
    initComponents();
    getRootPane().setDefaultButton(btnOK);    
  }
  
  private void initComponents() {
    btnOK = new javax.swing.JButton(AppletMathGraph32.getString("btnOK"));
    btnOK.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnOKActionPerformed(evt);
      }
    });    
    btnCancel = new javax.swing.JButton(AppletMathGraph32.getString("btnCancel"));
    btnCancel.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnCancelActionPerformed(evt);
      }
    });
    label1 = new JLabel(AppletMathGraph32.getString("variableDlg2"), JLabel.RIGHT);
    label1.setRequestFocusEnabled(false);
    label2 = new JLabel(AppletMathGraph32.getString("variableDlg3"), JLabel.RIGHT);
    label2.setRequestFocusEnabled(false);
    label3 = new JLabel(AppletMathGraph32.getString("variableDlg4"), JLabel.RIGHT);
    label3.setRequestFocusEnabled(false);
    label4 = new JLabel(AppletMathGraph32.getString("variableDlg5"), JLabel.RIGHT);
    label4.setRequestFocusEnabled(false);
    label5 = new JLabel(AppletMathGraph32.getString("variableDlg6"), JLabel.RIGHT);
    label5.setRequestFocusEnabled(false);
    editeurNom = new JTextField();
    editeurNom.setColumns(8);
    editeurValeurMini = new EditeurValeurConstante(applet);
    editeurValeurMaxi = new EditeurValeurConstante(applet);
    editeurValeurPas = new EditeurValeurConstante(applet);
    editeurValeurActuelle = new EditeurValeurConstante(applet);
  	editeurNom.setText(variableAModifier.nom());
  	editeurNom.setEditable(false);
  	editeurValeurMini.setText(variableAModifier.chaineValeurMini);
  	editeurValeurMaxi.setText(variableAModifier.chaineValeurMaxi);
  	editeurValeurPas.setText(variableAModifier.chaineValeurPas);
  	editeurValeurActuelle.setText(Kernel.chaineNombre(variableAModifier.valeurActuelle,12));
    JPanel paneLeft = new JPanel();
    JPanel paneRight = new JPanel();
    getContentPane().setLayout(new FlowLayout());
    paneLeft.setLayout(new GridBagLayout());
    paneRight.setLayout(new GridLayout(2, 1, 0, 5));
    
    GridBagConstraints constraints = new GridBagConstraints();
    constraints.insets.bottom = 5;
    constraints.insets.top = 5;
    constraints.insets.left = 5;
    constraints.insets.right = 5;
    
    setConstraints(constraints, 0, 0, 1, 1, 30, 20, GridBagConstraints.NONE, GridBagConstraints.WEST);
    paneLeft.add(label1, constraints);
    setConstraints(constraints, 1, 0, 1, 1, 70, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
    paneLeft.add(editeurNom, constraints);  
    setConstraints(constraints, 0, 1, 1, 1, 0, 20, GridBagConstraints.NONE, GridBagConstraints.EAST);
    paneLeft.add(label2, constraints);  
    setConstraints(constraints, 1, 1, 1, 1, 0, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
    paneLeft.add(editeurValeurMini, constraints);
	  setConstraints(constraints, 0, 2, 1, 1, 0, 20, GridBagConstraints.NONE, GridBagConstraints.EAST);
	  paneLeft.add(label3, constraints);  
	  setConstraints(constraints, 1, 2, 1, 1, 0, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
	  paneLeft.add(editeurValeurMaxi, constraints);
	  setConstraints(constraints, 0, 3, 1, 1, 0, 20, GridBagConstraints.NONE, GridBagConstraints.EAST);
	  paneLeft.add(label4, constraints);  
	  setConstraints(constraints, 1, 3, 1, 1, 0, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
	  paneLeft.add(editeurValeurPas, constraints);
	  setConstraints(constraints, 0, 4, 1, 1, 0, 20, GridBagConstraints.NONE, GridBagConstraints.EAST);
	  paneLeft.add(label5, constraints);  
	  setConstraints(constraints, 1, 4, 1, 1, 0, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
	  paneLeft.add(editeurValeurActuelle, constraints);
    paneRight.add(btnOK);
    paneRight.add(btnCancel);
    
    getContentPane().add(paneLeft);
    getContentPane().add(paneRight);
    pack();	  
	}
  
  private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {                                          
    dispose();
  }         
  
  private void btnOKActionPerformed(java.awt.event.ActionEvent evt) {
    if (!editeurValeurMini.verifieValidite()) {
    	editeurValeurMini.requestFocus();
    	return;
    }
    if (!editeurValeurMaxi.verifieValidite()) {
    	editeurValeurMaxi.requestFocus();
    	return;
    }
    if (!editeurValeurPas	.verifieValidite()) {
    	editeurValeurPas.requestFocus();
    	return;
    }
    if (!editeurValeurActuelle.verifieValidite()) {
    	editeurValeurActuelle.requestFocus();
    	return;
    }
    //On regarde si les valeurs donnes sont bien dans un ordre compatible
    double vMini = editeurValeurMini.resultat;
    double vMaxi = editeurValeurMaxi.resultat;
    double vPas = editeurValeurPas.resultat;
    double vActuelle = editeurValeurActuelle.resultat;
    if (vMini >= vMaxi ) {
    	dialogueAvertissement(AppletMathGraph32.getString("variableDlg8"));
    	editeurValeurMini.requestFocus();
    	return;
    }
    if (((vPas > vMaxi-vMini) || (vPas <= 0)) ) {
    	dialogueAvertissement(AppletMathGraph32.getString("variableDlg9"));
    	editeurValeurPas.requestFocus();
    	return;
    }
  	if ((vActuelle < vMini) || (vActuelle > vMaxi)) {
  		dialogueAvertissement(AppletMathGraph32.getString("variableDlg10"));
    	editeurValeurActuelle.requestFocus();
    	return;  		
  	}
  	// Tout est correct
  	variableAModifier.chaineValeurMini = editeurValeurMini.getText();
  	variableAModifier.valeurMini = vMini;
  	variableAModifier.chaineValeurMaxi = editeurValeurMaxi.getText();
  	variableAModifier.valeurMaxi = vMaxi;
  	variableAModifier.chaineValeurPas = editeurValeurPas.getText();
  	variableAModifier.valeurPas = vPas;
  	variableAModifier.valeurActuelle = vActuelle;

  	setRetourOK(true);
  	dispose();
  	applet.repaintFigureAvecCalcul();
  } 
}
