/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import objets.*;
import types.*;
import Applet.*;


/**
 *
 * @author Yves
 */
public class OutilMilieu extends OutilPar2pts {
  
  /** Creates a new instance of OutilMilieu */
  public OutilMilieu(AppletMathGraph32 appletMereInit) {
    super(appletMereInit, AppletMathGraph32.iconCreerMilieu);
  }
  
  public int idMenu() {
    return 32781;
  }
   
  public String toolTip() {
    return getString("toolTip13");
  }

  /* Appel pour crer finalement l'objet une fois que tous les objets dont il
   * dpend ont t dsigns */
  public void creeObjet() {
    CMilieu pt = new CMilieu(appletMere.listePr, null, false,
      appletMere.couleurActive(), MotifPoint.petitRond, point1, point2);   
    if (appletMere.ajouteElementAvecVerification(pt))
      appletMere.gestionnaire.enregistreFigureEnCours(getString("chaineOutil12"));
    select();
  }
  
  /* Mthode ajoutant les objets visuels  la liste listeObjetsVisuels de l'applet
   * au fur et  mesure que l'on dsigne les obejts  la souris
   * Doit tre redfini pour chaque outil utilisant une aide visuelle  la cration
   */
  public void ajouteObjetsVisuels() {
    CListeObjets liste = appletMere.listeObjetsVisuels;
    CMilieu ptm = new CMilieu(liste, null, false, appletMere.couleurActive(),
      MotifPoint.petitRond, point1, appletMere.pointSouris);
    liste.add(ptm);
  	// On cre deux segments en pointills
  	CSegment pts1 = new CSegment(liste, null, false, point1, ptm);
    liste.add(pts1);
  	CSegment pts2 = new CSegment(liste, null, false, ptm, appletMere.pointSouris);
    liste.add(pts2);
    // On cre une marque de segment pour les deux
    CMarqueSegment ptMarque1 = new CMarqueSegment(liste, null, false,
      Couleur.TraduitCouleur(1), false, StyleTrait.traitEpais,
      MotifMarqueSegment.MarqueSimple, pts1);
    liste.add(ptMarque1); 
    CMarqueSegment ptMarque2 = new CMarqueSegment(liste, null, false,
      Couleur.TraduitCouleur(1), false, StyleTrait.traitEpais,
      MotifMarqueSegment.MarqueSimple, pts2);
    liste.add(ptMarque2);
  }  
  public String chaineIndication (int indEtape) {
    switch(indEtape) {
      case 1 : return getString("milieu1");
      case 2 : return getString("milieu2");
      default: return "";
    }
  }
}
