/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 *
 * @author Yves
 * Outil anctre des outils de cration d'objets pas la cration successive de deux points
 */
package outils;

import java.awt.*;

import javax.swing.ImageIcon;

import objets.*;
import types.*;
import Applet.*;

public class OutilPar3pts extends Outil {
  CPointAncetre point1, point2, point3;
  // objetCre servira dans le cas ou les points dsigns doivent tre renomms
  // Si l'objet n'a pas t cr, il faudra raffecter  point1 et point2 leurs
  // anciens noms au cas o ceux-ci auraient t changs
  protected boolean objetCree;
  private boolean point1Nomme;
  private boolean point2Nomme;
  private boolean point3Nomme;
  /** Creates a new instance of OutilPar2pts */
  public OutilPar3pts(AppletMathGraph32 appletMereInit, ImageIcon iconeAssocieeInit) {
    super(appletMereInit,true, iconeAssocieeInit);
  }
  
  /**
   * Les outils descendant de OutilPar3Pts et necessitant que les points dsigns
   * soeint nomms s'ils n'ont pas de noms devront redfinir cette fonction en renvoyant true
   * Cela servira pour l'outil de mesure de longueur
   * @return true si les points dsigns doivent tre nomms
   */
  boolean nomsPointsIndisp() {
    return false;
  }
  
  /** Appel lorsque l'outil est slectionn */
  public void select() {
    super.select();
    point1 = null;
    point2 = null;
    point3 = null;
    designationDe(NatureObjet.NToutPoint);
    appletMere.indication(chaineIndication(1));
    objetCree = false;
  }
  
  /** Appel lorsque l'outil est dslectionn */
  public void deselect() {
    if (nomsPointsIndisp() && !objetCree) {
      if ((point1 != null) && point1Nomme) point1.donneNom("");
      if ((point2 != null) && point2Nomme) point2.donneNom("");
      if ((point3 != null) && point3Nomme) point3.donneNom("");
    }
    super.deselect();
  }
  
  /**
   * Action aprs dsignation du deuxime point
   * Ne fera rien et ne sera redfini qu pour l'outil de mesure d'ascisse
   */
  public void actionApresPoint2() {
    
  }
  
  
  /* Appel lorsqu'un objet a t cliqu pour tre trait par l'outil
   * par exemple le premier point pour crer une droite passant par deux points */
  public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
    if (point1 == null) {
      point1 = (CPointAncetre) elg;
      if (nomsPointsIndisp()) {
        if (point1.rendNom().length() == 0) {
          point1.donneNom(appletMere.listePr.genereNomPourPoint());
          point1Nomme =true;
        }
      }
      excluDeDesignation(elg);
      ajouteClignotementDe(elg);
      resetClignotement();
      appletMere.indication(chaineIndication(2));
    }
    else {
      if (point2 == null) {
        point2 = (CPointAncetre) elg;
        if (nomsPointsIndisp()) {
          if (point2.rendNom().length() == 0) {
            point2.donneNom(appletMere.listePr.genereNomPourPoint());
            point2Nomme =true;
          }
        }
        excluDeDesignation(elg);
        ajouteClignotementDe(elg); 
        ajouteObjetsVisuels();
        appletMere.indication(chaineIndication(3));
        actionApresPoint2();
      }
      else {
        if (point3 == null) {
          point3 = (CPointAncetre) elg;
          if (nomsPointsIndisp()) {
            if (point3.rendNom().length() == 0) {
              point3.donneNom(appletMere.listePr.genereNomPourPoint());
              point3Nomme =true;
            }
          }
          creeObjet();
          annuleClignotement();
        }
      }
    }
  }  
}
