/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 *
 * @author Yves
 * Outil anctre des outils construisant un objet pas la dsignation d'une droite suivie
 * d'un point
 */
package outils;

import objets.*;
import types.*;
import java.awt.*;

import javax.swing.ImageIcon;

import Applet.*;

public class OutilParDtPt extends Outil {
  CPointAncetre point1;
  CDroiteAncetre droite1;
  /** Creates a new instance of OutilParDtPt */
  public OutilParDtPt(AppletMathGraph32 appletMereInit, ImageIcon iconeAssocieeInit) {
    super(appletMereInit, true, iconeAssocieeInit);
  }
  /** Appel lorsque l'outil est slectionn */
  public void select() {
    super.select();
    point1 = null;
    droite1 = null;
    designationDe(NatureObjet.NTouteDroite);
    appletMere.indication(chaineIndication(1));
  }
  /* Appel lorsqu'un objet a t cliqu pour tre trait par l'outil
   * par exemple le premier point pour crer une droite passant par deux points */
  public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
    if (droite1 == null) {
      appletMere.indication(chaineIndication(2));
      droite1 = (CDroiteAncetre) elg;
      ajouteObjetsVisuels();
      excluDeDesignation(elg);
      ajouteClignotementDe(elg);
      resetClignotement();
      designationDe(NatureObjet.NToutPoint);
    }
    else {
      if (point1 == null) {
        point1 = (CPointAncetre) elg;
        creeObjet();
        annuleClignotement();
      }
    }
  }
  
}
