/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;
import Applet.*;
import java.awt.geom.*;

import objets.*;
import types.Doub;


/**
 *
 * @author Yves
 */
public class OutilPointageRapporteur extends OutilPointage {
  CPointLieCercle ptPointLieCercle = null;
  // Le champ x de pointabs contient la nouvelle abscisse d'un point
  // li qui doit tre dplac
  public static Doub pointabs = new Doub();
  // pointres contient les nouvelles coordonnes d'un point libre qui doit tre dplac
  public static Point2D.Double pointres = new Point2D.Double();
  
  /** Creates a new instance of OutilPointageRapporteur */
  public OutilPointageRapporteur(AppletMathGraph32 appletMere) {
    super(appletMere);
  }

  /** Fonction mettant dans ptPointLie un pointeur sur le pointli  un cercle que l'outil
   * est charg de faire bouger
   */
  public final void associePointLie(CPointLieCercle ptInit) {
    ptPointLieCercle = ptInit;
  }
  
  public void reset() {
    super.reset();
    ptPointLieCercle = null;
    appletMere.videDesignation();
  }
  
  public void mouseClicked(java.awt.event.MouseEvent mouseEvent) {
  }
  
  public void mouseMoved(java.awt.event.MouseEvent mouseEvent) {
     
    boolean poss = ptPointLieCercle.testDeplacement(appletMere.dimf,mouseEvent.getX(),
      mouseEvent.getY(), pointres, pointabs);
    if (poss)
    {
      ptPointLieCercle.donneAbscisse(pointabs.getValue());
      //appletMere.positionneListeVisuelle();
      appletMere.repaintFigure();
    }
  }
  public void mousePressed(java.awt.event.MouseEvent mouseEvent) {
    appletMere.outilActif.creeObjet();
  }
  
  public void mouseDragged(java.awt.event.MouseEvent mouseEvent) {

  }
  public void mouseReleased(java.awt.event.MouseEvent mouseEvent) {
  }

}
