/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 *
 * @author Yves
 */
package outils;

import objets.*;
import types.*;
import java.awt.*;
import Applet.*;

public class OutilPtLib extends Outil{
  Point pointDesigne;
  
  public int idMenu() {
    return 32779;
  }
  
  /** Creates a new instance of OutilPtLib */
  public OutilPtLib(AppletMathGraph32 appletMereInit) {
    super(appletMereInit, false, AppletMathGraph32.iconCreerPointLibre);
  }
  
  public String toolTip() {
    return getString("toolTip14");
  }
  
  public void select() {
    super.select();
    appletMere.outilPointageActif = appletMere.outilPointageClic;
    appletMere.indication(getString("pointLibre1"));
  }
  
  /* Appel lorsqu'un objet a t cliqu pour tre trait par l'outil
   * par exemple le premier point pour crer une droite passant par deux points */
  public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
    pointDesigne = pointClique;
    creeObjet();
  }
  /* Appel pour crer finalement l'objet une fois que tous les objets dont il
   * dpend ont t dsigns */
  public void creeObjet() {
    int x = pointDesigne.x;
    int y = pointDesigne.y;
    CPointBase pt = new CPointBase(appletMere.listePr, null, false,
      appletMere.couleurActive(), false, 0, 0, false, "", 2,
      MotifPoint.petitRond, true, x, y, false);
    if (appletMere.ajouteElementAvecVerification(pt))
      appletMere.gestionnaire.enregistreFigureEnCours(getString("chaineOutil1"));
    appletMere.repaintFigureAvecCalcul();
    select();
  }
  
	@Override
  public Cursor curseurUtilise() {
		return AppletMathGraph32.crayonCursor;
	}
  
}
